; ##############################################################################
; ##############################################################################
; ##############################################################################
; BEGRUNG																		
ANZEIGE_BEGRUESSUNG:
	; ZEILE1	
	;rcall LCD_CLEAR
	rcall LCD_ZEILE1
	ldi ZH, high(TEXT_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
	rcall ANZEIGE_TEXT
	; ZEILE2	
	rcall LCD_ZEILE2
	ldi ZH, high(TEXT_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
	rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ERROR:
	LDS temp,(adr_ERROR_CODE)
	tst temp
	brne ANZEIGE_ERROR_w
	ret
; ------------------------------------------------------------------------------
ANZEIGE_ERROR_w:
	LDS temp,(adr_MELDUNG_OFF)
	tst temp
	breq ANZEIGE_ERROR_w2
	ret
; ------------------------------------------------------------------------------
ANZEIGE_ERROR_w2:
	LDS temp,(adr_TASTE)
	tst temp
	breq ANZEIGE_ERROR_RUN
	ret
; ------------------------------------------------------------------------------
ANZEIGE_ERROR_RUN:
	rcall WAIT_100ms
	rcall WAIT_100ms
	rcall WAIT_100ms
	rcall WAIT_100ms
	; ZEILE1	
	rcall LCD_CLEAR
	rcall LCD_E
	rcall LCD_R
	rcall LCD_R
	rcall LCD_O
	rcall LCD_R
	; ZEILE2		
	rcall LCD_ZEILE2
	LDS temp1,(adr_ERROR_CODE)
	rcall ANZEIGE_HEX_TEMP1

	rcall WAIT_100ms
	rcall WAIT_100ms
	rcall WAIT_100ms
	rcall WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; 0x10 = DS18s22(rot)															
; 0x22 = DS1822 (braun)															
; 0x28 = DS18B20(gruen)															
;																				
ANZEIGE_SLAVE_NAME_TEMP1:
	cpi temp1,(0x10)
	brne ANZEIGE_SLAVE_NAME_NO_x10
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall LCD_D
	rcall LCD_S
	rcall LCD_1
	rcall LCD_8
	rcall LCD_s_
	rcall LCD_2
	rcall LCD_0
	; ZEILE2		
	rcall LCD_ZEILE2
	rcall LCD_r_
	rcall LCD_o_
	rcall LCD_t_
	ret
ANZEIGE_SLAVE_NAME_NO_x10:
; ------------------------------------------------------------------------------
	cpi temp1,(0x22)
	brne ANZEIGE_SLAVE_NAME_NO_x22
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall LCD_D
	rcall LCD_S
	rcall LCD_1
	rcall LCD_8
	rcall LCD_2
	rcall LCD_2
	; ZEILE2		
	rcall LCD_ZEILE2
	rcall LCD_b_
	rcall LCD_r_
	rcall LCD_a_
	rcall LCD_u_
	rcall LCD_n_
	ret
ANZEIGE_SLAVE_NAME_NO_x22:
; ------------------------------------------------------------------------------
	cpi temp1,(0x28)
	brne ANZEIGE_SLAVE_NAME_NO_x28
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall LCD_D
	rcall LCD_S
	rcall LCD_1
	rcall LCD_8
	rcall LCD_B
	rcall LCD_2
	rcall LCD_0
	; ZEILE2		
	rcall LCD_ZEILE2
	rcall LCD_g_
	rcall LCD_r_
	rcall LCD_u_
	rcall LCD_e_
	rcall LCD_n_
	ret
ANZEIGE_SLAVE_NAME_NO_x28:
; ------------------------------------------------------------------------------
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall LCD_FRAGEZEICHEN
	rcall LCD_FRAGEZEICHEN
	rcall LCD_FRAGEZEICHEN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ROM_ID:
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+0)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+1)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+2)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+3)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+4)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+5)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+6)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+7)
	rcall ANZEIGE_HEX_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_HISTORIE:
 	rcall LCD_H
	rcall LCD_I
	rcall LCD_S
	rcall LCD_T
	rcall LCD_O
 	rcall LCD_R
	rcall LCD_I
	rcall LCD_E
	rcall LCD_MINUS
	rcall LCD_R
	rcall LCD_O
	rcall LCD_M
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_RESET:
	rcall LCD_CLEAR
 	rcall LCD_R
	rcall LCD_E
	rcall LCD_S
	rcall LCD_E
	rcall LCD_T
	rcall LCD_PUNKT
	rcall LCD_PUNKT
	rcall LCD_PUNKT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_CLEAR:
	rcall LCD_CLEAR
 	rcall LCD_c_
	rcall LCD_l_
	rcall LCD_e_
	rcall LCD_a_
	rcall LCD_r_
	rcall LCD_PUNKT
	rcall LCD_PUNKT
	rcall LCD_PUNKT
	rcall WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
