; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	LDS temp,(adr_TASTE)
	tst temp
	breq MENUE_RUN
	rcall LCD_CLEAR
;-------------------------------------------------------------------------------
MENUE_RUN:
	; TASTEN-AUSWERTUNG	
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_MENUE_PLUS)
	breq MENUE_PLUS
	cpi temp,(TASTE_MENUE_MINUS)
	breq MENUE_MINUS
	rjmp MENUE_START
;-------------------------------------------------------------------------------
MENUE_PLUS:
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
	rjmp MENUE_START
;-------------------------------------------------------------------------------
MENUE_MINUS:
	LDS temp,(adr_MENUE)
	tst temp
	breq MENUE_START
	dec temp
	STS(adr_MENUE),temp
	rjmp MENUE_START
;-------------------------------------------------------------------------------
MENUE_START:
	ldi ZL,LOW (MENUE_SPRUNGMARKE)
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	add ZL,temp
	adc ZH,NULL
	ijmp ; Sprung nach Z
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	rjmp MENUE_ANZEIGE_ERGEBIS
	rjmp MENUE_ANZEIGE_WARTUNG
	rjmp MENUE_ANZEIGE_HISTORIE
	rjmp MENUE_ANZEIGE_RX_DATA
	rjmp MENUE_FEHLERMELDUNG_ON_OFF
	rjmp MENUE_BEEP_ON_OFF
	rjmp MENUE_WERKSEINSTELLUNG
	rjmp MENUE_SAVE
	rjmp ANZEIGE_BEGRUESSUNG
	rjmp MENUE_EDIT_ROM_ID	; 0
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID	; 10
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID	; 20
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID	; 30
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID	; 30
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID	; 40
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID	; 50
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	rjmp MENUE_EDIT_ROM_ID
	; START-MENUE		
	STS(adr_MENUE),NULL
	rjmp MENUE_START
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ANZEIGE_ERGEBIS:
	rcall TASTE_PLUS_C				; TASTE PLUS ?
	breq MENUE_ANZEIGE_ERGEBIS_INFO
	rjmp MENUE_ANZEIGE_ERGEBIS_RUN
MENUE_ANZEIGE_ERGEBIS_INFO:
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+0)
	rcall ANZEIGE_SLAVE_NAME_TEMP1
	rcall WAIT_1s
	rcall LCD_CLEAR
;---------------------------------------------------------------------------
MENUE_ANZEIGE_ERGEBIS_RUN:
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall ANZEIGE_ROM_ID
	; ZEILE2	
	rcall LCD_ZEILE2
;---------------------------------------------------------------------------
	LDS temp,(adr_OW_ROM_ID_BEREICH8+0)			; FAM		
	cpi temp,0x10
	brne MENUE_ANZEIGE_NO_x10
	rcall SCRATCHPAD_CRC8_C					; CRC		
	brcs MENUE_ANZEIGE_x10w
	rcall LCD_MINUS4
	ret
MENUE_ANZEIGE_x10w:
	rcall TEMPERATURBERECHNUNG_VARIANTE_9BIT
	rcall ANZEIGE_TEMPERATUR_KOMMA_TEMP1_2	; TEMPERATUR	
	ret
MENUE_ANZEIGE_NO_x10:
;---------------------------------------------------------------------------
	LDS temp,(adr_OW_ROM_ID_BEREICH8+0)			; FAM		
	cpi temp,0x22
	brne MENUE_ANZEIGE_NO_x22
	rcall SCRATCHPAD_CRC8_C					; CRC		
	brcs MENUE_ANZEIGE_x22w
	rcall LCD_MINUS4
	ret
MENUE_ANZEIGE_x22w:
	rcall TEMPERATURBERECHNUNG_VARIANTE_12BIT
	rcall ANZEIGE_TEMPERATUR_KOMMA_TEMP1_2	; TEMPERATUR	
	ret
MENUE_ANZEIGE_NO_x22:
;---------------------------------------------------------------------------
	LDS temp,(adr_OW_ROM_ID_BEREICH8+0)			; FAM		
	cpi temp,0x28
	brne MENUE_ANZEIGE_NO_x28
	rcall SCRATCHPAD_CRC8_C					; CRC		
	brcs MENUE_ANZEIGE_x28w
	rcall LCD_MINUS4
	ret
MENUE_ANZEIGE_x28w:
	rcall TEMPERATURBERECHNUNG_VARIANTE_12BIT
	rcall ANZEIGE_TEMPERATUR_KOMMA_TEMP1_2	; TEMPERATUR	
	ret
MENUE_ANZEIGE_NO_x28:
;---------------------------------------------------------------------------


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ANZEIGE_WARTUNG:
	; ZEILE1	
	rcall LCD_ZEILE1
	LDS temp1,(adr_OW_ANZAHL_SLAVES)
	rcall LCD_S
	rcall LCD_L
	rcall LCD_A
	rcall LCD_V
	rcall LCD_E
	rcall LCD_S
	rcall LCD_DOPPELPUNKT
	rcall ANZEIGE_2_STELLEN_TEMP1
	; ZEILE2	
	rcall LCD_ZEILE2
	rcall LCD_R
	rcall LCD_P
	rcall LCD_Z
	rcall LCD_DOPPELPUNKT
	LDS temp1,(adr_OW_ZAEHLER_RP_L)
	LDS temp2,(adr_OW_ZAEHLER_RP_H)
	rcall ANZEIGE_5_STELLEN_TEMP1_TEMP2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ANZEIGE_HISTORIE:
	rcall TASTE_PLUS_C				; TASTE PLUS ?
	breq MENUE_ANZEIGE_HISTORIE_INFO
	rjmp MENUE_ANZEIGE_HISTORIE_RUN
MENUE_ANZEIGE_HISTORIE_INFO:
	; ZEILE1	
	rcall LCD_ZEILE1
 	rcall ANZEIGE_TEXT_HISTORIE
	rcall WAIT_1s
	rcall LCD_CLEAR
; ------------------------------------------------------------------------------
MENUE_ANZEIGE_HISTORIE_RUN:
	LDS temp,(adr_OW_HIST_ROM_BEREICH+0)
	tst temp
	brne MENUE_ANZEIGE_HISTORIE_ACTION
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall LCD_H
	rcall LCD_I
	rcall LCD_S
	rcall LCD_T
	ret
; ------------------------------------------------------------------------------
MENUE_ANZEIGE_HISTORIE_ACTION:
	; ZEILE1	
	rcall LCD_ZEILE1
 	ldi ZL,low (adr_OW_HIST_ROM_BEREICH)
    ldi ZH,high(adr_OW_HIST_ROM_BEREICH) 
	rcall MENUE_ANZEIGE_HISTORIE_DETAIL
 	; ZEILE2	
	rcall LCD_ZEILE2
	rcall MENUE_ANZEIGE_HISTORIE_DETAIL
	ret
;---------------------------------------------------------------------------
MENUE_ANZEIGE_HISTORIE_DETAIL:
	rcall MENUE_ANZEIGE_HISTORIE_WERT
	rcall MENUE_ANZEIGE_HISTORIE_WERT
	rcall MENUE_ANZEIGE_HISTORIE_WERT
ret
;---------------------------------------------------------------------------
MENUE_ANZEIGE_HISTORIE_WERT:
	LD temp1,Z+
	tst temp1
	brne MENUE_ANZEIGE_HISTORIE_w
	ret
MENUE_ANZEIGE_HISTORIE_w:
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	tst temp1
	brne MENUE_ANZEIGE_HISTORIE_2
	rcall LCD_SPACE
	rcall LCD_SPACE
	rcall LCD_MINUS
	ret
MENUE_ANZEIGE_HISTORIE_2:
	rcall ANZEIGE_HEX_TEMP1
	rcall LCD_MINUS
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ANZEIGE_RX_DATA:
	rcall TASTE_PLUS_C				; TASTE PLUS ?
	breq MENUE_ANZEIGE_RX_DATA_INFO
	rjmp MENUE_ANZEIGE_RX_DATA_RUN
MENUE_ANZEIGE_RX_DATA_INFO:
	; ZEILE1	
	rcall LCD_ZEILE1
 	rcall LCD_D
 	rcall LCD_A
 	rcall LCD_T
 	rcall LCD_A
	rcall WAIT_1s
	rcall LCD_CLEAR
; ------------------------------------------------------------------------------
MENUE_ANZEIGE_RX_DATA_RUN:
	LDS temp,(adr_OW_RX_DATA256)
	tst temp
	brne MENUE_ANZEIGE_RX_DATA_ACTION
	; ZEILE1	
	rcall LCD_CLEAR
 	rcall LCD_MINUS2
 	rcall LCD_MINUS2	
 	rcall LCD_MINUS2
 	rcall LCD_MINUS2
	ret
; ------------------------------------------------------------------------------
MENUE_ANZEIGE_RX_DATA_ACTION:
	; ZEILE1	
	rcall LCD_ZEILE1
 	ldi ZL,low (adr_OW_RX_DATA256)
    ldi ZH,high(adr_OW_RX_DATA256) 
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	; ZEILE2	
	rcall LCD_ZEILE2
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_WERKSEINSTELLUNG:
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall LCD_W	
	rcall LCD_E	
	rcall LCD_R	
	rcall LCD_K	
	rcall LCD_SPACE	
	rcall LCD_FRAGEZEICHEN
	rcall TASTE_PLUS_C				; TASTE PLUS ?
	breq MENUE_WERKSEINSTELLUNG_RUN
	ret
; ------------------------------------------------------------------------------
MENUE_WERKSEINSTELLUNG_RUN:
	STS(adr_WERKSEINSTELLUNG),NULL
	rcall EEPROM_KONFIGURATION_SAVE
	rjmp RESET_WDR
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SAVE:
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall LCD_S
	rcall LCD_A	
	rcall LCD_V	
	rcall LCD_E	
	rcall LCD_SPACE	
	rcall LCD_FRAGEZEICHEN
	rcall TASTE_PLUS_C				; TASTE PLUS ?
	breq MENUE_SAVE_RUN
	ret
; ------------------------------------------------------------------------------
MENUE_SAVE_RUN:
	rcall EEPROM_KONFIGURATION_SAVE
	STS(adr_MENUE),NULL
	rcall WAIT_100ms
	rcall LCD_CLEAR
	rcall LCD_O	
	rcall LCD_K	
	rcall WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_FEHLERMELDUNG_ON_OFF:
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall LCD_M
	rcall LCD_E
	rcall LCD_L
	rcall LCD_D
	rcall LCD_U
	rcall LCD_N
	rcall LCD_G
	rcall LCD_SPACE
	rcall LCD_o_
	rcall LCD_f_
	rcall LCD_f_
	; ZEILE2	
	rcall LCD_ZEILE2

	rcall TASTE_PLUS_C				; TASTE PLUS ?
	brne MENUE_FEHLERMELDUNG_ON_OFF_RUN
	LDS temp,(adr_MELDUNG_OFF)
	inc temp
	andi temp,0b00000001
	STS(adr_MELDUNG_OFF),temp
; ------------------------------------------------------------------------------
MENUE_FEHLERMELDUNG_ON_OFF_RUN:
	LDS temp1,(adr_MELDUNG_OFF)
	rcall ANZEIGE_2_STELLEN_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_BEEP_ON_OFF:
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall LCD_B
	rcall LCD_E
	rcall LCD_E
	rcall LCD_P
	rcall LCD_SPACE
	rcall LCD_o_
	rcall LCD_f_
	rcall LCD_f_
	; ZEILE2	
	rcall LCD_ZEILE2
	rcall TASTE_PLUS_C				; TASTE PLUS ?
	brne MENUE_BEEP_ON_OFF_RUN
	LDS temp,(adr_BEEP_OFF)
	inc temp
	andi temp,0b00000001
	STS(adr_BEEP_OFF),temp
; ------------------------------------------------------------------------------
MENUE_BEEP_ON_OFF_RUN:
	LDS temp1,(adr_BEEP_OFF)
	rcall ANZEIGE_2_STELLEN_TEMP1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_ROM_ID:
	LDS temp,(adr_MENUE_OFFSET)  ; MENUE-OFFSET
	tst temp
	brne MERID_w
	LDS temp,(adr_MENUE)		; MENUE			
	STS(adr_MENUE_OFFSET),temp  ; MENUE-OFFSET	
MERID_w:
	LDS temp,(adr_OW_ANZAHL_SLAVES)
	tst temp
	brne MENUE_EDIT_ROM_ID_RUN
	LDS temp,(adr_MENUE_OFFSET) ; MENUE-OFFSET
	STS(adr_MENUE),temp			; MENUE			
	rcall LCD_ZEILE1			; ZEILE			
	rcall LCD_n_
	rcall LCD_o_
	rcall LCD_SPACE
	rcall LCD_S
	rcall LCD_l_
	rcall LCD_a_
	rcall LCD_v_
	rcall LCD_e_
	rcall LCD_s_
	ret
; ------------------------------------------------------------------------------
MENUE_EDIT_ROM_ID_RUN:
	LDS temp1,(adr_MENUE)
	inc temp1
	LDS temp,(adr_MENUE_OFFSET) ; MENUE-OFFSET
	sub temp1,temp  			; MENUE-OFFSET

	LDS temp,(adr_OW_ANZAHL_SLAVES)
	cp temp,temp1
	brsh MENUE_EDIT_ROM_ID_ACTION
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall LCD_PUNKT3
	LDS temp,(adr_MENUE_OFFSET) ; MENUE-OFFSET
	STS(adr_MENUE),temp
	ret
; ------------------------------------------------------------------------------
MENUE_EDIT_ROM_ID_ACTION:
	; ZEILE1	
	rcall LCD_ZEILE1
	rcall LCD_S
	rcall LCD_l_
	rcall LCD_a_
	rcall LCD_v_
	rcall LCD_e_
	rcall LCD_SPACE

	LDS temp1,(adr_MENUE)
	inc temp1
	LDS temp,(adr_MENUE_OFFSET) ; MENUE-OFFSET
	sub temp1,temp  			; MENUE-OFFSET
	rcall ANZEIGE_2_STELLEN_TEMP1
	rcall LCD_SPACE
	rcall LCD_v_
	rcall LCD_o_
	rcall LCD_n_
	rcall LCD_SPACE
	LDS temp1,(adr_OW_ANZAHL_SLAVES)
	rcall ANZEIGE_2_STELLEN_TEMP1
	; ZEILE2	
	rcall LCD_ZEILE2
 	ldi ZL,low (adr_ROM_LISTE)
    ldi ZH,high(adr_ROM_LISTE) 

	LDS temp1,(adr_MENUE)
	LDS temp,(adr_MENUE_OFFSET) ; MENUE-OFFSET
	sub temp1,temp  			; MENUE-OFFSET

	ldi temp,8
	MUL temp1,temp
	add ZL,R0
	adc ZH,R1

	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1
	LD temp1,Z+
	rcall ANZEIGE_HEX_TEMP1

	rcall TASTE_PLUS_C				; TASTE PLUS ?
	breq MENUE_EDIT_ROM_ID_SAVE
	ret
; ------------------------------------------------------------------------------
MENUE_EDIT_ROM_ID_SAVE:
	SBIW ZL,8		; -8
	LD temp,Z+
	STS(adr_OW_ROM_ID_BEREICH8+0),temp
	LD temp,Z+
	STS(adr_OW_ROM_ID_BEREICH8+1),temp
	LD temp,Z+
	STS(adr_OW_ROM_ID_BEREICH8+2),temp
	LD temp,Z+
	STS(adr_OW_ROM_ID_BEREICH8+3),temp
	LD temp,Z+
	STS(adr_OW_ROM_ID_BEREICH8+4),temp
	LD temp,Z+
	STS(adr_OW_ROM_ID_BEREICH8+5),temp
	LD temp,Z+
	STS(adr_OW_ROM_ID_BEREICH8+6),temp
	LD temp,Z+
	STS(adr_OW_ROM_ID_BEREICH8+7),temp
	rcall SCRATCHPAD_CLEAR
	rcall EEPROM_KONFIGURATION_SAVE
	STS(adr_MENUE),NULL
	rcall WAIT_100ms
	rcall LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################




